#pragma once

#include <FL/Fl.H>
#include <FL/Fl_Gl_Window.H>
#include <GL/glut.h>
#include "v3.h"
#include "ppc.h"

class FrameBuffer : public Fl_Gl_Window {
public:
  unsigned int *pix;
  int w, h;
  float *zb;
  FrameBuffer(int u0, int v0, int _w, int _h);
  void FrameSetup();
  void Set(unsigned int color);
  void Set(int u, int v, unsigned int color);
  unsigned int Get(int u, int v);
  void SetGuarded(int u, int v, 
    unsigned int color);
  bool IsCloserThenSet(int ui, int vi, float z);
  bool IsInShadow(V3 projP);
  void draw();
  void KeyboardHandle();
  int handle(int guievent);
  void MakeChecker(int cw, unsigned int col0,
    unsigned int col1);
  void DrawPoint3D(V3 P, int psize, 
    unsigned int pcol, PPC *ppc);
  void DrawPoint3D(V3 P, int psize, 
    V3 c0, V3 c1, PPC *ppc);
  void DrawSegment3D(V3 P0, 
    V3 P1, unsigned int scol, PPC *ppc);
  void DrawSegment3D(V3 P0, 
    V3 P1, V3 c0, V3 c1, PPC *ppc);
  void DrawSegment2D(V3 projP0, V3 projP1, 
    V3 c0, V3 c1);
  void Save(char *fname);
  int Load(char *tiffFileName);
  V3 LookUp(float s, float t);

};
